﻿package object3ds.factoryObject3d 
{
	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.utils.getDefinitionByName;
	import org.ascollada.fx.DaeBindMaterial;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	
	/**
	 * createMaterialsListメソッドで渡されるmaterialsInfoの情報をもとにMatelialsListを作成します。
	 * テクスチャは重複して作成しないように処理しています。
	 * @author hagiwara
	 */
	public class FactoryMaterialsList extends EventDispatcher
	{
		public static const PREPARE_MATERIALSLIST:String = "prepareMaterialsList"; //未処理
		public static const PROGRESS_MATERIALSLIST:String = "progressMaterialsList";//処理中
		public static const COMPLETE_MATERIALSLIST:String = "completeMaterialsList";//完了
		
		private var materialsListInfo:Array;		//textureNameとmaterialSymbolをプロパティとしてもつオブジェクトの配列
		private var _materialsList:MaterialsList;	//最終的に作成するmaterialsList ゲッターあり
		private var materials:Array;				//実テクスチャデータを持つ配列
		
		public function FactoryMaterialsList() 
		{
			
		}
		
		public function createMaterialsList(materialsListInfo:Array):void 
		{
			this.materialsListInfo = materialsListInfo;
			_materialsList = new MaterialsList();
			materials = new Array();
			
			for (var i:int = 0; i < materialsListInfo.length; i++) {
				var tempName:String = materialsListInfo[i].textureName ;
				
				var flg:int = 0;
				
				for (var j:int = 0; j < materials.length; j++) {
					if (tempName == materials[j][0]) {
						flg++; 
					}
				}
				
				if (flg == 0) {					
					var textureClass:Class = Class(getDefinitionByName(materialsListInfo[i].textureName));
					var textureData:BitmapData = new textureClass(0, 0);
					var material:BitmapMaterial = new BitmapMaterial(textureData);
					materials.push(new Array(materialsListInfo[i].textureName, material));				
				}
				
				for (var k:int = 0; k < materials.length; k++) {
					if (materialsListInfo[i].textureName == materials[k][0]) {
						_materialsList.addMaterial(materials[k][1],
											materialsListInfo[i].materialSymbol
											);
					}
				}
				
				
			}
			
			this.dispatchEvent(new Event(COMPLETE_MATERIALSLIST));	
			
		}
		
		
		
		/*以下セッターとゲッター*/
		public function get materialsList():MaterialsList
		{
			return _materialsList;
		}
	}

}